<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/backtrace-0.3.66/src/print.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>print.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../backtrace/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
</pre><pre class="rust"><code><span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">BacktraceFrame</span>, <span class="ident">BacktraceSymbol</span>};
<span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">BytesOrWideString</span>, <span class="ident">Frame</span>, <span class="ident">SymbolName</span>};
<span class="kw">use</span> <span class="ident">core::ffi::c_void</span>;
<span class="kw">use</span> <span class="ident">core::fmt</span>;

<span class="kw">const</span> <span class="ident">HEX_WIDTH</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">2</span> <span class="op">+</span> <span class="number">2</span> <span class="op">*</span> <span class="ident">core::mem::size_of</span>::<span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>();

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;fuchsia&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">fuchsia</span>;

<span class="doccomment">/// A formatter for backtraces.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This type can be used to print a backtrace regardless of where the backtrace</span>
<span class="doccomment">/// itself comes from. If you have a `Backtrace` type then its `Debug`</span>
<span class="doccomment">/// implementation already uses this printing format.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">BacktraceFmt</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span> {
    <span class="ident">fmt</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;b</span><span class="op">&gt;</span>,
    <span class="ident">frame_index</span>: <span class="ident">usize</span>,
    <span class="ident">format</span>: <span class="ident">PrintFmt</span>,
    <span class="ident">print_path</span>:
        <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> (<span class="kw">dyn</span> <span class="ident">FnMut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>, <span class="ident">BytesOrWideString</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> <span class="op">+</span> <span class="lifetime">&#39;b</span>),
}

<span class="doccomment">/// The styles of printing that we can print</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Eq</span>, <span class="ident">PartialEq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">PrintFmt</span> {
    <span class="doccomment">/// Prints a terser backtrace which ideally only contains relevant information</span>
    <span class="ident">Short</span>,
    <span class="doccomment">/// Prints a backtrace that contains all possible information</span>
    <span class="ident">Full</span>,
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">__Nonexhaustive</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span> <span class="ident">BacktraceFmt</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Create a new `BacktraceFmt` which will write output to the provided</span>
    <span class="doccomment">/// `fmt`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The `format` argument will control the style in which the backtrace is</span>
    <span class="doccomment">/// printed, and the `print_path` argument will be used to print the</span>
    <span class="doccomment">/// `BytesOrWideString` instances of filenames. This type itself doesn&#39;t do</span>
    <span class="doccomment">/// any printing of filenames, but this callback is required to do so.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(
        <span class="ident">fmt</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;b</span><span class="op">&gt;</span>,
        <span class="ident">format</span>: <span class="ident">PrintFmt</span>,
        <span class="ident">print_path</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> (<span class="kw">dyn</span> <span class="ident">FnMut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>, <span class="ident">BytesOrWideString</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span>
                     <span class="op">+</span> <span class="lifetime">&#39;b</span>),
    ) -&gt; <span class="self">Self</span> {
        <span class="ident">BacktraceFmt</span> {
            <span class="ident">fmt</span>,
            <span class="ident">frame_index</span>: <span class="number">0</span>,
            <span class="ident">format</span>,
            <span class="ident">print_path</span>,
        }
    }

    <span class="doccomment">/// Prints a preamble for the backtrace about to be printed.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is required on some platforms for backtraces to be fully</span>
    <span class="doccomment">/// symbolicated later, and otherwise this should just be the first method</span>
    <span class="doccomment">/// you call after creating a `BacktraceFmt`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">add_context</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;fuchsia&quot;</span>)]</span>
        <span class="ident">fuchsia::print_dso_context</span>(<span class="self">self</span>.<span class="ident">fmt</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(())
    }

    <span class="doccomment">/// Adds a frame to the backtrace output.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This commit returns an RAII instance of a `BacktraceFrameFmt` which can be used</span>
    <span class="doccomment">/// to actually print a frame, and on destruction it will increment the</span>
    <span class="doccomment">/// frame counter.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">frame</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">BacktraceFrameFmt</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, <span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span> {
        <span class="ident">BacktraceFrameFmt</span> {
            <span class="ident">fmt</span>: <span class="self">self</span>,
            <span class="ident">symbol_index</span>: <span class="number">0</span>,
        }
    }

    <span class="doccomment">/// Completes the backtrace output.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is currently a no-op but is added for future compatibility with</span>
    <span class="doccomment">/// backtrace formats.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">finish</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="comment">// Currently a no-op-- including this hook to allow for future additions.</span>
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="doccomment">/// A formatter for just one frame of a backtrace.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This type is created by the `BacktraceFmt::frame` function.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">BacktraceFrameFmt</span><span class="op">&lt;</span><span class="lifetime">&#39;fmt</span>, <span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span> {
    <span class="ident">fmt</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;fmt</span> <span class="kw-2">mut</span> <span class="ident">BacktraceFmt</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span>,
    <span class="ident">symbol_index</span>: <span class="ident">usize</span>,
}

<span class="kw">impl</span> <span class="ident">BacktraceFrameFmt</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, <span class="lifetime">&#39;_</span>, <span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Prints a `BacktraceFrame` with this frame formatter.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This will recursively print all `BacktraceSymbol` instances within the</span>
    <span class="doccomment">/// `BacktraceFrame`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Required features</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This function requires the `std` feature of the `backtrace` crate to be</span>
    <span class="doccomment">/// enabled, and the `std` feature is enabled by default.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">backtrace_frame</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">frame</span>: <span class="kw-2">&amp;</span><span class="ident">BacktraceFrame</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="kw">let</span> <span class="ident">symbols</span> <span class="op">=</span> <span class="ident">frame</span>.<span class="ident">symbols</span>();
        <span class="kw">for</span> <span class="ident">symbol</span> <span class="kw">in</span> <span class="ident">symbols</span> {
            <span class="self">self</span>.<span class="ident">backtrace_symbol</span>(<span class="ident">frame</span>, <span class="ident">symbol</span>)<span class="question-mark">?</span>;
        }
        <span class="kw">if</span> <span class="ident">symbols</span>.<span class="ident">is_empty</span>() {
            <span class="self">self</span>.<span class="ident">print_raw</span>(<span class="ident">frame</span>.<span class="ident">ip</span>(), <span class="prelude-val">None</span>, <span class="prelude-val">None</span>, <span class="prelude-val">None</span>)<span class="question-mark">?</span>;
        }
        <span class="prelude-val">Ok</span>(())
    }

    <span class="doccomment">/// Prints a `BacktraceSymbol` within a `BacktraceFrame`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Required features</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This function requires the `std` feature of the `backtrace` crate to be</span>
    <span class="doccomment">/// enabled, and the `std` feature is enabled by default.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">backtrace_symbol</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">frame</span>: <span class="kw-2">&amp;</span><span class="ident">BacktraceFrame</span>,
        <span class="ident">symbol</span>: <span class="kw-2">&amp;</span><span class="ident">BacktraceSymbol</span>,
    ) -&gt; <span class="ident">fmt::Result</span> {
        <span class="self">self</span>.<span class="ident">print_raw_with_column</span>(
            <span class="ident">frame</span>.<span class="ident">ip</span>(),
            <span class="ident">symbol</span>.<span class="ident">name</span>(),
            <span class="comment">// TODO: this isn&#39;t great that we don&#39;t end up printing anything</span>
            <span class="comment">// with non-utf8 filenames. Thankfully almost everything is utf8 so</span>
            <span class="comment">// this shouldn&#39;t be too too bad.</span>
            <span class="ident">symbol</span>
                .<span class="ident">filename</span>()
                .<span class="ident">and_then</span>(<span class="op">|</span><span class="ident">p</span><span class="op">|</span> <span class="prelude-val">Some</span>(<span class="ident">BytesOrWideString::Bytes</span>(<span class="ident">p</span>.<span class="ident">to_str</span>()<span class="question-mark">?</span>.<span class="ident">as_bytes</span>()))),
            <span class="ident">symbol</span>.<span class="ident">lineno</span>(),
            <span class="ident">symbol</span>.<span class="ident">colno</span>(),
        )<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(())
    }

    <span class="doccomment">/// Prints a raw traced `Frame` and `Symbol`, typically from within the raw</span>
    <span class="doccomment">/// callbacks of this crate.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">symbol</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">frame</span>: <span class="kw-2">&amp;</span><span class="ident">Frame</span>, <span class="ident">symbol</span>: <span class="kw-2">&amp;</span><span class="ident"><span class="kw">super</span>::Symbol</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="self">self</span>.<span class="ident">print_raw_with_column</span>(
            <span class="ident">frame</span>.<span class="ident">ip</span>(),
            <span class="ident">symbol</span>.<span class="ident">name</span>(),
            <span class="ident">symbol</span>.<span class="ident">filename_raw</span>(),
            <span class="ident">symbol</span>.<span class="ident">lineno</span>(),
            <span class="ident">symbol</span>.<span class="ident">colno</span>(),
        )<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(())
    }

    <span class="doccomment">/// Adds a raw frame to the backtrace output.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This method, unlike the previous, takes the raw arguments in case</span>
    <span class="doccomment">/// they&#39;re being source from different locations. Note that this may be</span>
    <span class="doccomment">/// called multiple times for one frame.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">print_raw</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">frame_ip</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
        <span class="ident">symbol_name</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">SymbolName</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">filename</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">BytesOrWideString</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">lineno</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>,
    ) -&gt; <span class="ident">fmt::Result</span> {
        <span class="self">self</span>.<span class="ident">print_raw_with_column</span>(<span class="ident">frame_ip</span>, <span class="ident">symbol_name</span>, <span class="ident">filename</span>, <span class="ident">lineno</span>, <span class="prelude-val">None</span>)
    }

    <span class="doccomment">/// Adds a raw frame to the backtrace output, including column information.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This method, like the previous, takes the raw arguments in case</span>
    <span class="doccomment">/// they&#39;re being source from different locations. Note that this may be</span>
    <span class="doccomment">/// called multiple times for one frame.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">print_raw_with_column</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">frame_ip</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
        <span class="ident">symbol_name</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">SymbolName</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">filename</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">BytesOrWideString</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">lineno</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>,
        <span class="ident">colno</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>,
    ) -&gt; <span class="ident">fmt::Result</span> {
        <span class="comment">// Fuchsia is unable to symbolize within a process so it has a special</span>
        <span class="comment">// format which can be used to symbolize later. Print that instead of</span>
        <span class="comment">// printing addresses in our own format here.</span>
        <span class="kw">if</span> <span class="macro">cfg!</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;fuchsia&quot;</span>) {
            <span class="self">self</span>.<span class="ident">print_raw_fuchsia</span>(<span class="ident">frame_ip</span>)<span class="question-mark">?</span>;
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="ident">print_raw_generic</span>(<span class="ident">frame_ip</span>, <span class="ident">symbol_name</span>, <span class="ident">filename</span>, <span class="ident">lineno</span>, <span class="ident">colno</span>)<span class="question-mark">?</span>;
        }
        <span class="self">self</span>.<span class="ident">symbol_index</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        <span class="prelude-val">Ok</span>(())
    }

    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_mut</span>)]</span>
    <span class="kw">fn</span> <span class="ident">print_raw_generic</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="kw-2">mut</span> <span class="ident">frame_ip</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
        <span class="ident">symbol_name</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">SymbolName</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">filename</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">BytesOrWideString</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">lineno</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>,
        <span class="ident">colno</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>,
    ) -&gt; <span class="ident">fmt::Result</span> {
        <span class="comment">// No need to print &quot;null&quot; frames, it basically just means that the</span>
        <span class="comment">// system backtrace was a bit eager to trace back super far.</span>
        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">PrintFmt::Short</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">format</span> {
            <span class="kw">if</span> <span class="ident">frame_ip</span>.<span class="ident">is_null</span>() {
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(());
            }
        }

        <span class="comment">// To reduce TCB size in Sgx enclave, we do not want to implement symbol</span>
        <span class="comment">// resolution functionality.  Rather, we can print the offset of the</span>
        <span class="comment">// address here, which could be later mapped to correct function.</span>
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>, <span class="ident">target_env</span> <span class="op">=</span> <span class="string">&quot;sgx&quot;</span>, <span class="ident">target_vendor</span> <span class="op">=</span> <span class="string">&quot;fortanix&quot;</span>))]</span>
        {
            <span class="kw">let</span> <span class="ident">image_base</span> <span class="op">=</span> <span class="ident">std::os::fortanix_sgx::mem::image_base</span>();
            <span class="ident">frame_ip</span> <span class="op">=</span> <span class="ident">usize::wrapping_sub</span>(<span class="ident">frame_ip</span> <span class="kw">as</span> <span class="ident">usize</span>, <span class="ident">image_base</span> <span class="kw">as</span> <span class="kw">_</span>) <span class="kw">as</span> <span class="kw">_</span>;
        }

        <span class="comment">// Print the index of the frame as well as the optional instruction</span>
        <span class="comment">// pointer of the frame. If we&#39;re beyond the first symbol of this frame</span>
        <span class="comment">// though we just print appropriate whitespace.</span>
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">symbol_index</span> <span class="op">==</span> <span class="number">0</span> {
            <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;{:4}: &quot;</span>, <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">frame_index</span>)<span class="question-mark">?</span>;
            <span class="kw">if</span> <span class="kw">let</span> <span class="ident">PrintFmt::Full</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">format</span> {
                <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;{:1$?} - &quot;</span>, <span class="ident">frame_ip</span>, <span class="ident">HEX_WIDTH</span>)<span class="question-mark">?</span>;
            }
        } <span class="kw">else</span> {
            <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;      &quot;</span>)<span class="question-mark">?</span>;
            <span class="kw">if</span> <span class="kw">let</span> <span class="ident">PrintFmt::Full</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">format</span> {
                <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;{:1$}&quot;</span>, <span class="string">&quot;&quot;</span>, <span class="ident">HEX_WIDTH</span> <span class="op">+</span> <span class="number">3</span>)<span class="question-mark">?</span>;
            }
        }

        <span class="comment">// Next up write out the symbol name, using the alternate formatting for</span>
        <span class="comment">// more information if we&#39;re a full backtrace. Here we also handle</span>
        <span class="comment">// symbols which don&#39;t have a name,</span>
        <span class="kw">match</span> (<span class="ident">symbol_name</span>, <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">format</span>) {
            (<span class="prelude-val">Some</span>(<span class="ident">name</span>), <span class="ident">PrintFmt::Short</span>) =&gt; <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;{:#}&quot;</span>, <span class="ident">name</span>)<span class="question-mark">?</span>,
            (<span class="prelude-val">Some</span>(<span class="ident">name</span>), <span class="ident">PrintFmt::Full</span>) =&gt; <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;{}&quot;</span>, <span class="ident">name</span>)<span class="question-mark">?</span>,
            (<span class="prelude-val">None</span>, <span class="kw">_</span>) <span class="op">|</span> (<span class="kw">_</span>, <span class="ident">PrintFmt::__Nonexhaustive</span>) =&gt; <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;&lt;unknown&gt;&quot;</span>)<span class="question-mark">?</span>,
        }
        <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>.<span class="ident">write_str</span>(<span class="string">&quot;\n&quot;</span>)<span class="question-mark">?</span>;

        <span class="comment">// And last up, print out the filename/line number if they&#39;re available.</span>
        <span class="kw">if</span> <span class="kw">let</span> (<span class="prelude-val">Some</span>(<span class="ident">file</span>), <span class="prelude-val">Some</span>(<span class="ident">line</span>)) <span class="op">=</span> (<span class="ident">filename</span>, <span class="ident">lineno</span>) {
            <span class="self">self</span>.<span class="ident">print_fileline</span>(<span class="ident">file</span>, <span class="ident">line</span>, <span class="ident">colno</span>)<span class="question-mark">?</span>;
        }

        <span class="prelude-val">Ok</span>(())
    }

    <span class="kw">fn</span> <span class="ident">print_fileline</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">file</span>: <span class="ident">BytesOrWideString</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>,
        <span class="ident">line</span>: <span class="ident">u32</span>,
        <span class="ident">colno</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>,
    ) -&gt; <span class="ident">fmt::Result</span> {
        <span class="comment">// Filename/line are printed on lines under the symbol name, so print</span>
        <span class="comment">// some appropriate whitespace to sort of right-align ourselves.</span>
        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">PrintFmt::Full</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">format</span> {
            <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;{:1$}&quot;</span>, <span class="string">&quot;&quot;</span>, <span class="ident">HEX_WIDTH</span>)<span class="question-mark">?</span>;
        }
        <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;             at &quot;</span>)<span class="question-mark">?</span>;

        <span class="comment">// Delegate to our internal callback to print the filename and then</span>
        <span class="comment">// print out the line number.</span>
        (<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">print_path</span>)(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="ident">file</span>)<span class="question-mark">?</span>;
        <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;:{}&quot;</span>, <span class="ident">line</span>)<span class="question-mark">?</span>;

        <span class="comment">// Add column number, if available.</span>
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">colno</span>) <span class="op">=</span> <span class="ident">colno</span> {
            <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;:{}&quot;</span>, <span class="ident">colno</span>)<span class="question-mark">?</span>;
        }

        <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;\n&quot;</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(())
    }

    <span class="kw">fn</span> <span class="ident">print_raw_fuchsia</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">frame_ip</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="comment">// We only care about the first symbol of a frame</span>
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">symbol_index</span> <span class="op">==</span> <span class="number">0</span> {
            <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>.<span class="ident">write_str</span>(<span class="string">&quot;{{{bt:&quot;</span>)<span class="question-mark">?</span>;
            <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>, <span class="string">&quot;{}:{:?}&quot;</span>, <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">frame_index</span>, <span class="ident">frame_ip</span>)<span class="question-mark">?</span>;
            <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">fmt</span>.<span class="ident">write_str</span>(<span class="string">&quot;}}}\n&quot;</span>)<span class="question-mark">?</span>;
        }
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="kw">impl</span> <span class="ident">Drop</span> <span class="kw">for</span> <span class="ident">BacktraceFrameFmt</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, <span class="lifetime">&#39;_</span>, <span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">drop</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">frame_index</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="backtrace" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>